library shaded_text;

import 'package:flutter/material.dart';

typedef ShadedBuilder = Widget Function(
    BuildContext context, String text, Color textColor);

class ShadedText extends StatelessWidget {
  final String text;
  final Color textColor;
  final Color shadeColor;
  final double xTans;
  final double yTans;
  final ShadedBuilder shadedBuilder;

  ShadedText(
      {this.text,
      this.textColor,
      this.shadeColor,
      this.xTans,
      this.yTans,
      this.shadedBuilder})
      : assert(text != null),
        assert(textColor != null),
        assert(shadeColor != null),
        assert(shadedBuilder != null);

  @override
  Widget build(BuildContext context) {
    return Stack(
      children: <Widget>[
        shadedBuilder(context, text, textColor),
        Transform(
          transform: Matrix4.translationValues(xTans ?? 10, yTans ?? 10, 0),
          child: shadedBuilder(context, text, shadeColor),
        )
      ],
    );
  }
}
